-- ========================================= 
-- ========================================= 
--  .. 1
-- 27.12.2023  prsys_kiosk_mango_getphones_bills
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE dbo.prsys_kiosk_mango_getphones_bills
	@dtBeg datetime,
	@dtEnd datetime
AS
BEGIN
	SET NOCOUNT ON;
	declare @tab_clients table (id_clienta nvarchar(50), idglobal_clinic uniqueidentifier, summaBills money)
	insert into @tab_clients
	(id_clienta, idglobal_clinic, summaBills)
	select id_clienta, idglobal_Clinic, sum(isnull(SUMMA_BILL, 0)) from repl_aa_b_bill
	where date_bill between @dtBeg and @dtEnd
	and (not (ID_CLIENTA='99-001-000000'))
	group by id_clienta, idglobal_Clinic;
	select [dbo].[fn_onlyPhoneNomber](a2.tel_sot) as clientPhone, sum(summaBills) as SumBills from @tab_clients a1
	inner join repl_Clients a2 on ((a2.ID_Client=a1.id_clienta) and (a2.idglobal_clinic=a1.idglobal_clinic)) 
	group by a2.tel_sot
END
GO



-- ========================================= 
-- ========================================= 
--  .. 2
-- 27.12.2023 2
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
ALTER PROCEDURE [dbo].[pr_ashnew_karta_list_services_without_bills] 
   @idglobal_Clinic uniqueidentifier,
   @ID_CLIENT nvarchar(150)
AS
BEGIN
	SET NOCOUNT ON;
	declare @idkart_table table (idkart nvarchar(50));
	declare @docum_table table  (docum_code nvarchar(150), idkart nvarchar(50));
	declare @serv_table table   (id_clienta nvarchar(50), docum_Code nvarchar(150), id_service int, service_count int, service_procent float, ind_services int, preal float, iddoctor int, iduser int, dtlch datetime)
	declare @res_table table (idkart nvarchar(50), docum_Code nvarchar(150), sumserv money);
	

	insert into @idkart_table
	select IDKART from repl_Pacients
	where idglobal_Clinic=@idglobal_Clinic
	and ID_Client=@ID_CLIENT;

	insert into @docum_table
	select docum_Code, IDKart_P from repl_HH_HISTORY_DOCUMENTS
	where (idglobal_Clinic=@idglobal_Clinic)
	and (idkart_P in (select idkart from @idkart_table));
	 
	insert into @serv_table
	select id_clienta, DOCUM_CODE, id_service, service_count, service_procent, IND_SERVICES, preal, iddoctor, iduser, dtlch from repl_AA_AA_CLIENT_SERVICE
	where idglobal_clinic=@idglobal_Clinic
	and (IDBILL is NULL)
	and (docum_Code in (select docum_Code from @docum_table));
	
	insert into @res_table
	select  A2.idkart,A1.docum_Code, sum(A1.preal) as SumSev from @serv_table A1
	left join @docum_table A2 on A2.docum_code=A1.docum_Code
	group by  A2.idkart, A1.docum_Code;

	select A1.idkart,cast(dbo.repl_fn_getPETInfo(A1.idkart, @idglobal_Clinic) as nvarchar(250) )as PetINfo, 
	A2.DatDoc,   A3.HH_DOC_NAME, A1.docum_Code,A1.sumserv, a2.idglobal_clinic, a2.gl_docum_code from  @res_table A1
	left join repl_HH_HISTORY_DOCUMENTS A2
	on (A2.idglobal_Clinic=@idglobal_Clinic and A2.DOCUM_CODE=A1.docum_Code )
	left join dbo.cfg_HH_DOC_CODES A3 ON A3.HH_DOC_CODE=A2.HH_DOC_CODE;
END

GO

-- =========================================

-- ========================================= 
-- ========================================= 
--  .. 1
-- 23.01.2024   prsys_getRecomendation
-- ========================================= 
-- ========================================= 

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE dbo.prsys_getRecomendation 
	@gl_docum_code uniqueidentifier
AS
BEGIN
	SET NOCOUNT ON;
	
	declare @docum_code nvarchar(50);
    declare @idglobal_clinic uniqueidentifier;


	declare @cnt_docum int;
	select @cnt_docum=count(*) from    repl_HH_HISTORY_DOCUMENTS a1
    where gl_docum_code=@gl_docum_code;

  if isnull(@cnt_docum, 0)=1
  begin 
     --     
	select @docum_code=a1.docum_code, @idglobal_clinic=a1.idglobal_clinic 
	from repl_HH_HISTORY_DOCUMENTS a1 where a1.gl_docum_code=@gl_docum_code
  end;

   declare @recomTxt nvarchar(max);

   select top 1 @recomTxt=RECOMENDTXT from dbo.repl_HH_RECOMEND
   where docum_code=@docum_code and idglobal_clinic=@idglobal_clinic

   select isnull(@recomTxt, '') as recom

END
GO

-- ========================================= 
-- ========================================= 
--  .. 2
-- 25.01.2024   prsys_kiosk_set_recom
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE dbo.prsys_kiosk_set_recom
	@gl_docum_code uniqueidentifier,
	@txtRecom nvarchar(max)
AS
BEGIN
	SET NOCOUNT ON;
	--    
	declare @cnt int;

	select @cnt=count(*) from repl_HH_HISTORY_DOCUMENTS
	where gl_docum_code=@gl_docum_code 

	if (not (isnull(@cnt, 0)=0))
	 begin
	    --   
		declare @docum_code nvarchar(50);
		declare @idglobal_clinic uniqueidentifier;
		select @docum_code=docum_Code, @idglobal_clinic=idglobal_clinic
		from repl_HH_HISTORY_DOCUMENTS where gl_docum_code=@gl_docum_code
		-- 
		declare @cntRecom int;
		select @cntRecom=count(*) from repl_HH_RECOMEND
		where DOCUM_CODE=@docum_code and idglobal_clinic=@idglobal_clinic;
		if isnull(@cntRecom, 0)=0 begin
		   declare @newid uniqueidentifier;
		   set @newid=newid();
		   insert into repl_HH_RECOMEND
		   (IDRECOMEND, DOCUM_CODE, idglobal_clinic, RECOMENDTXT)
		   values (@newid, @docum_code, @idglobal_clinic, @txtRecom)
		end else begin
		           update repl_HH_RECOMEND
				   set RECOMENDTXT=@txtRecom
				   where DOCUM_CODE=@docum_code and idglobal_clinic=@idglobal_clinic
		         end
	 end;
END
GO

-- ========================================= 
-- ========================================= 
--  .. 3
-- 25.01.2024    fnDecodeBase64
-- ========================================= 
-- ========================================= 
create function fnDecodeBase64 (@encoded as varchar(max))
returns varchar(max)
as
begin

    declare @decoded varchar(max)

    set @decoded = cast('' as xml).value('xs:base64Binary(sql:variable("@encoded"))', 'varbinary(max)')

    return @decoded

end

go

-- ========================================= 
-- ========================================= 
--  .. 4
-- 26.01.2024   pr_cl_tab_sel_repl_HH_SHABLONES
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE procedure [dbo].[pr_cl_tab_sel_repl_HH_SHABLONES]
  @IDShablone uniqueidentifier
 as 
 BEGIN 
	select 
	[IDShablone],[NShablone],[IDDoctor],[SelfShablone],[idglobal_clinic]
	from repl_HH_SHABLONES
	where [IDShablone]=@IDShablone
 END;
GO


-- ========================================= 
-- ========================================= 
--  .. 5
-- 26.01.2024  pr_cl_tab_ins_repl_HH_SHABLONES
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[pr_cl_tab_ins_repl_HH_SHABLONES] 
@IDShablone uniqueidentifier,@NShablone varchar (150),@IDDoctor int,@SelfShablone bit,@idglobal_clinic uniqueidentifier
AS 
BEGIN
SET NOCOUNT ON;
insert into [dbo].[repl_HH_SHABLONES]
 (
 [IDShablone],[NShablone],[IDDoctor],[SelfShablone],[idglobal_clinic]
 )
 values (
 @IDShablone,@NShablone,@IDDoctor,@SelfShablone,@idglobal_clinic
 );
 END;
GO


-- ========================================= 
-- ========================================= 
--  .. 6
-- 26.01.2024  pr_cl_tab_upd_repl_HH_SHABLONES
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[pr_cl_tab_upd_repl_HH_SHABLONES](@IDShablone uniqueidentifier,@idglobal_clinic uniqueidentifier,@NShablone varchar (150),@IDDoctor int,@SelfShablone bit)
AS 
BEGIN
SET NOCOUNT ON;
update [dbo].[repl_HH_SHABLONES]
 set 
 [NShablone]=@NShablone,[IDDoctor]=@IDDoctor,[SelfShablone]=@SelfShablone
  where IDShablone=@IDShablone and idglobal_clinic=@idglobal_clinic;
 END;
GO




-- ========================================= 
-- ========================================= 
--  .. 7
-- 26.01.2024   prsys_getSamlpeOfRecomendation
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE prsys_getSamlpeOfRecomendation 
	@idShablone uniqueidentifier
AS
BEGIN
   SET NOCOUNT ON;
   declare @ShabloneTXT nvarchar(max);
   select @ShabloneTXT=[ShabloneTXT] from repl_HH_SHABLONES
   where IDShablone=@idShablone
   select @ShabloneTXT as shablone;
END
GO


-- ========================================= 
-- ========================================= 
--  .. 8
-- 26.01.2024   prsys_kiosk_set_recom_sample
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[prsys_kiosk_set_recom_sample]
	@id_sample uniqueidentifier,
	@txtRecom nvarchar(max)
AS
BEGIN
	SET NOCOUNT ON;
	--    
	declare @cnt int;

	select @cnt=count(*) from [dbo].[repl_HH_SHABLONES]
	where [IDShablone]=@id_sample 

	if (not (isnull(@cnt, 0)=0))
	 begin
	    --   
		 update [dbo].[repl_HH_SHABLONES]
		 set [ShabloneTXT]=@txtRecom
		 where [IDShablone]=@id_sample
	 end;
	 --     
	 select 200;
END
GO


-- ========================================= 
-- ========================================= 
--  .. 9
-- 31.01.2024   prsys_getValueOfConfigParam
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[prsys_getValueOfConfigParam]
	@idParam nvarchar(50)
AS
BEGIN
	SET NOCOUNT ON;

	select valpar as value_param_str from [dbo].[repl_av_params]
	where idglobal_clinic=dbo.getClinicID()
	and idpar=@idParam

END
GO


-- ========================================= 
-- ========================================= 
--  .. 10
-- 05.02.2024   prsys_kiosk_listshablones
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE dbo.prsys_kiosk_listshablones

AS
BEGIN
	SET NOCOUNT ON;
	
	
	declare @jsonData nvarchar(max);
	set @jsonData=(
select a1.NShablone as NShablone, a1.IDShablone as IDShablone, a2.NameDoc as NameDoc from [dbo].[repl_HH_SHABLONES] a1
inner join repl_avuser a2 on ((a2.IDDoctor=a1.IDDoctor) and (a2.idglobal_clinic=a1.idglobal_clinic)) 
    where a1.idglobal_Clinic=dbo.getClinicID()	FOR JSON PATH)
	select @jsonData as JsonData


END
GO


-- ========================================= 
-- ========================================= 
--  .. 11
-- 10.02.2024    
-- ========================================= 
-- ========================================= 


declare @tab table (idmenu_param uniqueidentifier, id_cfgmenu uniqueidentifier, NameCfgParametr nvarchar(150), TypeParametr int, ValueParametr nvarchar(150))

insert into @tab  (idmenu_param, id_cfgmenu, NameCfgParametr, TypeParametr, ValueParametr)
values ('BFEA4057-267E-446E-9674-189052DDB412', '3B03A698-8041-4845-B9B1-627D535D1D6C', '.  ', 1, 1);
insert into @tab  (idmenu_param, id_cfgmenu, NameCfgParametr, TypeParametr, ValueParametr)
values ('C23F9354-2EDF-4776-A8A9-B1FECEC8E1B1', '3B03A698-8041-4845-B9B1-627D535D1D6C', '.     ', 1, 1);
insert into @tab  (idmenu_param, id_cfgmenu, NameCfgParametr, TypeParametr, ValueParametr)
values ('406ACC7E-1933-42C3-AADB-A8E07F617E39', '3B03A698-8041-4845-B9B1-627D535D1D6C', '.     ', 1, 1);


insert into  [dbo].[cfg_menuparametrs_configsettings]
(idmenu_param, id_cfgmenu, NameCfgParametr, TypeParametr, ValueParametr)
select idmenu_param, id_cfgmenu, NameCfgParametr, TypeParametr, ValueParametr from @tab
where idmenu_param not in (select idmenu_param from [dbo].[cfg_menuparametrs_configsettings]);

go


-- ========================================= 
-- ========================================= 
--  .. 12
-- 10.02.2024   prsys_kiosk_get_paramsPrintBill
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[prsys_kiosk_get_paramsPrintBill]
  @jsonParams nvarchar(max) output
AS
BEGIN

	SET NOCOUNT ON;

--//;;     
--//;; 1. .    
--;; BFEA4057-267E-446E-9674-189052DDB412
--;; 2. .   
--;; C23F9354-2EDF-4776-A8A9-B1FECEC8E1B1
--;; 3. .   
--;; 406ACC7E-1933-42C3-AADB-A8E07F617E39

  declare @isPrintRekv int; 
  declare @isPrintDoctor int;
  declare @isPrintDirector int;

  select @isPrintRekv=cast([ValueParametr] as int) from [dbo].[cfg_menuparametrs_configsettings]
  where [idmenu_param]='BFEA4057-267E-446E-9674-189052DDB412';

  select @isPrintDoctor=cast([ValueParametr] as int) from [dbo].[cfg_menuparametrs_configsettings]
  where [idmenu_param]='C23F9354-2EDF-4776-A8A9-B1FECEC8E1B1';

  select @isPrintDirector=cast([ValueParametr] as int) from [dbo].[cfg_menuparametrs_configsettings]
  where [idmenu_param]='406ACC7E-1933-42C3-AADB-A8E07F617E39';

  declare @tab table (isPrintRekv int, isPrintDoctor int, isPrintDirector int);
  insert into  @tab 
  (isPrintRekv, isPrintDoctor, isPrintDirector)
  values (@isPrintRekv, @isPrintDoctor, @isPrintDirector)

  set @jsonParams= (select * from  @tab for json auto)


  return


END
GO

-- ========================================= 
-- ========================================= 
--  .. 13
-- 12.02.2024  prsys_vesoft_consist_ofBill_json
-- ========================================= 
-- ========================================= 
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[prsys_vesoft_consist_ofBill_json]
	@gl_id_bill uniqueidentifier, @json_data nvarchar(max) output
AS
BEGIN
    -- Version 1.0.1 --  12/10/2023
	-- Version 2.0.1 --  12/02/2024
	SET NOCOUNT ON;

	declare @ErrCode int, @ErrMessage nvarchar(500);
	declare @control_summa_bill money;
	declare @date_bill datetime;
	declare @id_bill int;
	declare @idglobal_clinic uniqueidentifier;
    declare @json_bill_info nvarchar(max),@json_bill_details nvarchar(max),@json_clinic_rekvis nvarchar(max);
	declare @logobase64 nvarchar(max), @imgSign nvarchar(max), @txtPodvalBill nvarchar(max);
	declare @taxinfo nvarchar(250), @tax_sum money, @tax_value int, @id_uni_templink_code uniqueidentifier;

	declare @bill_info table (gl_id_bill uniqueidentifier, date_bill nvarchar(50), control_summa_bill money, id_bill int, idglobal_clinic uniqueidentifier, 
    nomber_bill nvarchar(50), sum_string nvarchar(300), idclient nvarchar(50), taxinfo nvarchar(250), kioskcode nvarchar(50), dtEndKioskcode datetime, doctorfio nvarchar(250))



	select @logobase64=dbo.f_BinaryToBase64(HTML_VAL)	FROM   [dbo].[cfg_AA_HTML_PARS]	WHERE  IDHTML_PAR='IMG_LOGO';
	select @imgSign=dbo.f_BinaryToBase64(HTML_VAL)	from  [dbo].[cfg_AA_HTML_PARS]	WHERE  IDHTML_PAR='img_sign1';
	select @txtPodvalBill=html_txt from  [dbo].[cfg_AA_HTML_PARS] where IDHTML_PAR='bill_podval';




	select @TAX_SUM=taxsum, @TAX_VALUE=taxvalue, @id_uni_templink_code=id_uni_templink_code from repl_AA_B_BILL
	WHERE gl_id_bill=@gl_id_bill
-- and idglobal_clinic=@idglobal_clinic
--     
IF ISNULL(@TAX_VALUE,0)=0 BEGIN
   SET @taxinfo=N'  '  
END ELSE BEGIN
            SET @taxinfo=N'<b> ..  '+cast(@TAX_VALUE as nvarchar(10))+N'%: '+cast(@TAX_SUM as nvarchar(150))+N'.</b>'  
           END

declare @kioskcode nvarchar(50);
declare @dtEndKioskcode datetime;


select @kioskcode=kioskcode, @dtEndKioskcode=dtEnd from [dbo].[avst_kiosk_codes]
where id_uni_templink_code=@id_uni_templink_code
and ((isUsed=0) or (isUsed is null)) 

select top 1 @kioskcode=kioskCode from [dbo].[avst_kiosk_codes]
where id_uni_templink_code=@id_uni_templink_code



insert into @bill_info
select top 1 gl_id_bill, [dbo].[fn_ashfin_DateOnlyToString](date_bill), SUMMA_BILL, id_bill, idglobal_clinic , nomber_bill, 
ISNULL(dbo.RubPhrase(SUMMA_BILL),''), ID_CLIENTA, @taxinfo, @kioskcode, @dtEndKioskcode, [dbo].[repl_fn_getDoctorFIO](IDDoctor, Idglobal_Clinic) from repl_AA_B_BILL
where gl_id_bill=@gl_id_bill


    declare @idclient nvarchar(50);



	declare @cnt int;

    select @cnt=count(*) from  @bill_info
	if not (isnull(@cnt, 0)=0)
	begin
	    --  
		set @ErrCode=200;
		set @json_bill_info=(select kioskcode, gl_id_bill, date_bill, control_summa_bill, nomber_bill, sum_string, idclient, taxinfo, doctorfio from @bill_info FOR JSON PATH) 
		--      
		select top 1 @id_bill=id_bill, @idglobal_clinic=idglobal_clinic  from @bill_info
		--    json

		declare @tab_details table (idnom int, namesoder nvarchar(500), countsoder int, service_procent float, price money, price_wsk money, edism nvarchar(150), summa_svc money);
		insert into @tab_details
		(idnom, namesoder, countsoder, service_procent, price, price_wsk, edism, summa_svc)
		select ROW_NUMBER() over (ORDER BY namesoder ASC) AS Row#, namesoder, countsoder, service_procent, price, price_wsk, edism, summa_svc 
								from dbo.repl_fn_GetBillsSoder(@id_bill, @idglobal_clinic)

		set @json_bill_details=(select idnom, namesoder, countsoder, service_procent, price, price_wsk, edism, summa_svc 
								from @tab_details for json path)


   set  @json_clinic_rekvis=(select rekprint,inn, kpp,bik, bankname,rs,ks,ShName, ruk_dolzhnost as managerPosition, ruk_fio as managerName 
							 from [dbo].[repl_fn_tab_listClinic]() where idglobal_clinic=dbo.getClinicID() for json auto);


--        
--    -    
   declare @clientinfo nvarchar(max);
   declare @petinfo nvarchar(max);
   set @clientinfo=dbo.fnsys_kiosk_getClientInfo(@gl_id_bill);
   set @petinfo=dbo.fnsys_kiosk_getPetInfo(@gl_id_bill);

   --     ....
   declare @jsonParams nvarchar(max);
   exec [dbo].[prsys_kiosk_get_paramsPrintBill] @jsonParams=@jsonParams output;
   --;; select @jsonParams


--   
--    
		set @json_bill_info=isnull(N'"bill_info" : '+@json_bill_info+',', '');
		set @json_data=N'{'+N'"ErrCode" : '+cast(@ErrCode as nvarchar(20))+', "Data" : '+N'{'+@json_bill_info+isnull(N'"bill_Services" : '+@json_bill_details+'', '')+
        isnull(N', "clinicinfo" :'+@json_clinic_rekvis,'')+
        isnull(N', "logo" : "'+@logobase64+N'"', '')+
		isnull(N', "imgSign" : "'+@imgSign+N'"', '')+
		isnull(N', "textBillPodval" : "'+@txtPodvalBill+N'"', '')+
		isnull(N', "clientinfo" : "'+@clientinfo+N'"', '')+
	  -- isnull(N', "petinfo" : "'+@petinfo+N'"', '')+'}}';		
		 isnull(N', "petinfo" : "'+@petinfo+N'"', '')+'}, "Params" : '+@jsonParams+'}';

		-- isnull(N'"params" : '+@jsonParams+N'', '')+
		--       -  
	end else begin
	            --   
				set @ErrCode=500;
				set @ErrMessage='Bill Not Found';
				set @json_data=N'{'+N'"ErrCode" : '+cast(@ErrCode as nvarchar(20))+', "ErrMessage" : '+'"'+@ErrMessage+'"}';
			 end;

	return;

END

go









